package com.ejie.ab79.control;

import java.util.Date;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.SessionAttributes;

import com.ejie.ab79.clientesWS.ab61WebService.Usuario;
import com.ejie.ab79.model.RelOriDir;
import com.ejie.ab79.model.inspecciones.OrigenesInspeccion;
import com.ejie.ab79.model.procedimientos.Direcciones;
import com.ejie.ab79.service.RelOriDirService;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;

/**
 * InformeTecnicoController  
 * 
 *  
 */
@SessionAttributes("usuario")
@Controller
@RequestMapping(value = "/relOriDir")

public class RelacionOrigenInspeccionDireccionController {

	private static final Logger logger = LoggerFactory.getLogger(RelacionOrigenInspeccionDireccionController.class);

	@Autowired
	private RelOriDirService relOriDirService;

	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		RelacionOrigenInspeccionDireccionController.logger.info("[GET - View] : preguntasValidar");
		return "relOriInsp";
	}

	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<RelOriDir> filter(
			@RequestJsonBody(param = "filter") RelOriDir filterPreguntas,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		RelacionOrigenInspeccionDireccionController.logger.info("[POST - filter] : Obtener PreguntasProtocolo");
		return this.relOriDirService.filter(filterPreguntas, tableRequestDto, false);
	}

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idRelOriDir
	 *            Integer
	 * @return RelOriDir Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idRelOriDir}", method = RequestMethod.GET)
	public @ResponseBody RelOriDir get(@PathVariable Long idRelOriDir) {

		RelacionOrigenInspeccionDireccionController.logger.info("[GET - findBy_PK] : Obtener RelOriDir por PK");

		RelOriDir relOriDir = new RelOriDir();
		relOriDir.setIdRelOriDir(idRelOriDir);
		return this.relOriDirService.find(relOriDir);
	}

	/**
	 * Actualizar RelOriDir
	 * 
	 * @param relOriDir
	 * @param usuario
	 * @return
	 */
	@RequestMapping(value = "/updateRelOriDir", method = RequestMethod.PUT)
	public @ResponseBody RelOriDir updateRelOriDir(@RequestBody RelOriDir relOriDir,
			@ModelAttribute("usuario") Usuario usuario) {

		RelacionOrigenInspeccionDireccionController.logger.info("[PUT] : Actualizar RelOriDir");

		RelOriDir relOriDirBD = this.relOriDirService.find(relOriDir);
		relOriDirBD.setFechaUltmodificacion(new Date());
		relOriDirBD.setUsuarioUltmodificacion(usuario.getUsuario());
		relOriDirBD.setInformeTecnico(relOriDir.getInformeTecnico());
		return this.relOriDirService.update(relOriDirBD);
	}

	@RequestMapping(value = "/findByOrigenDireccion/{idOrigenInspeccion}/{idDireccion}", method = RequestMethod.GET)
	public @ResponseBody RelOriDir findByOrigenDireccion(@PathVariable Integer idOrigenInspeccion,
			@PathVariable Integer idDireccion) {

		RelacionOrigenInspeccionDireccionController.logger.info("[GET - findBy_PK] : Obtener RelOriDir por PK");

		RelOriDir relOriDir = new RelOriDir();
		relOriDir.setOrigenInspeccion(new OrigenesInspeccion(idOrigenInspeccion));
		relOriDir.setDireccion(new Direcciones(idDireccion));
		return this.relOriDirService.findByOrigenDireccion(relOriDir);
	}
}
